import { BaseInstrumentation } from '@grafana/agent-core';
import { TextMapPropagator, ContextManager } from '@opentelemetry/api';
import { InstrumentationOption } from '@opentelemetry/instrumentation';
import { ResourceAttributes } from '@opentelemetry/resources';
import { SpanProcessor } from '@opentelemetry/sdk-trace-base';
export interface TracingInstrumentationOptions {
    resourceAttributes?: ResourceAttributes;
    propagator?: TextMapPropagator;
    contextManager?: ContextManager;
    instrumentations?: InstrumentationOption[];
    spanProcessor?: SpanProcessor;
}
export declare function getDefaultOTELInstrumentations(ignoreUrls?: Array<string | RegExp>): InstrumentationOption[];
export declare class TracingInstrumentation extends BaseInstrumentation {
    private options;
    name: string;
    version: string;
    static SCHEDULED_BATCH_DELAY_MS: number;
    constructor(options?: TracingInstrumentationOptions);
    initialize(): void;
    private getIgnoreUrls;
}
