var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
import { ExportResultCode } from '@opentelemetry/core';
import { createExportTraceServiceRequest } from '@opentelemetry/otlp-transformer';
export class GrafanaAgentTraceExporter {
    constructor(config) {
        this.config = config;
    }
    export(spans, resultCallback) {
        const traceEvent = exportTraceServiceRequestToTraceEvent(createExportTraceServiceRequest(spans, true));
        this.config.agent.api.pushTraces(traceEvent);
        resultCallback({ code: ExportResultCode.SUCCESS });
    }
    shutdown() {
        return Promise.resolve(undefined);
    }
}
// @TODO temporary, transforming trace export request to earlier version where "scope" -> "instrumentationLibrary"
function exportTraceServiceRequestToTraceEvent(req) {
    const { resourceSpans } = req, rest = __rest(req, ["resourceSpans"]);
    return Object.assign(Object.assign({}, rest), { resourceSpans: resourceSpans === null || resourceSpans === void 0 ? void 0 : resourceSpans.map((rsp) => {
            const { scopeSpans } = rsp, rest = __rest(rsp, ["scopeSpans"]);
            return Object.assign(Object.assign({}, rest), { instrumentationLibrarySpans: scopeSpans === null || scopeSpans === void 0 ? void 0 : scopeSpans.map((scopeSpan) => {
                    const { scope } = scopeSpan, rest = __rest(scopeSpan, ["scope"]);
                    return Object.assign(Object.assign({}, rest), { instrumentationLibrary: scope });
                }) });
        }) });
}
//# sourceMappingURL=agent-exporter.js.map